Index: localdir.cc
===================================================================
RCS file: /cvs/src/src/winsup/cinstall/localdir.cc,v
retrieving revision 2.3
diff -u -p -r2.3 localdir.cc
--- localdir.cc	2001/11/06 03:41:00	2.3
+++ localdir.cc	2001/11/11 06:54:56
@@ -15,11 +15,13 @@
  */
 
 /* The purpose of this file is to ask the user where they want the
-   root of the installation to be, and to ask whether the user prefers
-   text or binary mounts. */
+ * locally downloaded package files to be cached
+ */
 
-static char *cvsid =
-  "\n%%% $Id: localdir.cc,v 2.3 2001/11/06 03:41:00 rbcollins Exp $\n";
+#if 0
+static const char *cvsid =
+  "\n%%% $Id: localdir.cc,v 2.2 2001/11/01 13:22:46 rbcollins Exp $\n";
+#endif
 
 #include "win32.h"
 #include <shlobj.h>
@@ -35,34 +37,23 @@ static char *cvsid =
 #include "concat.h"
 #include "log.h"
 #include "mkdir.h"
+#include "io_stream.h"
 
-static void
-get_root_dir_now ()
-{
-  int istext;
-  int issystem;
-  if (get_root_dir ())
-    return;
-  read_mounts ();
-}
-
 void
 save_local_dir ()
 {
-  get_root_dir_now ();
-  if (!get_root_dir ())
-    return;
-
   mkdir_p (1, local_dir);
 
-  FILE *f = fopen (cygpath ("/etc/setup/last-cache", 0), "wb");
-  if (!f)
-    return;
-  fprintf (f, "%s", local_dir);
-  fclose (f);
+  io_stream *f = io_stream::open ("cygfile:///etc/setup/last-cache", "wb");
+  if (f)
+    {
+      char temp[1000];
+      sprintf (temp, "%s", local_dir);
+      f->write (temp, strlen (temp));
+      delete f;
+    }
 }
 
-
 static void
 check_if_enable_next (HWND h)
 {
@@ -116,7 +107,6 @@ browse (HWND h)
     }
 }
 
-
 static BOOL
 dialog_cmd (HWND h, int id, HWND hwndctl, UINT code)
 {
@@ -176,6 +166,7 @@ dialog_cmd (HWND h, int id, HWND hwndctl
       NEXT (0);
       break;
     }
+  return 0;
 }
 
 static BOOL CALLBACK
@@ -200,13 +191,13 @@ do_local_dir (HINSTANCE h)
   static int inited = 0;
   if (!inited)
     {
-      FILE *f = fopen (cygpath ("/etc/setup/last-cache", 0), "rt");
+      io_stream *f =
+	io_stream::open ("cygfile:///etc/setup/last-cache", "rt");
       if (f)
 	{
 	  char localdir[1000];
-	  localdir[0] = '\0';
-	  char *fg_ret = fgets (localdir, 1000, f);
-	  fclose (f);
+	  char *fg_ret = f->gets (localdir, 1000);
+	  delete f;
 	  if (fg_ret)
 	    {
 	      free (local_dir);
Index: log.cc
===================================================================
RCS file: /cvs/src/src/winsup/cinstall/log.cc,v
retrieving revision 2.4
diff -u -p -r2.4 log.cc
--- log.cc	2001/05/27 07:05:09	2.4
+++ log.cc	2001/11/11 06:54:57
@@ -15,7 +15,10 @@
 
 /* The purpose of this file is to centralize all the logging functions. */
 
-static char *cvsid = "\n%%% $Id: log.cc,v 2.4 2001/05/27 07:05:09 cgf Exp $\n";
+#if 0
+static const char *cvsid =
+  "\n%%% $Id: log.cc,v 2.4 2001/05/27 07:05:09 cgf Exp $\n";
+#endif
 
 #include "win32.h"
 #include <stdio.h>
@@ -32,7 +35,8 @@ static char *cvsid = "\n%%% $Id: log.cc,
 #include "mkdir.h"
 #include "mount.h"
 
-struct LogEnt {
+struct LogEnt
+{
   LogEnt *next;
   int flags;
   time_t when;
@@ -43,7 +47,7 @@ static LogEnt *first_logent = 0;
 static LogEnt **next_logent = &first_logent;
 
 void
-log (int flags, char *fmt, ...)
+log (int flags, const char *fmt, ...)
 {
   char buf[1000];
   va_list args;
@@ -70,7 +74,7 @@ log (int flags, char *fmt, ...)
 }
 
 void
-log_save (int babble, char *filename, int append)
+log_save (int babble, const char *filename, int append)
 {
   static int been_here = 0;
   if (been_here)
@@ -88,12 +92,12 @@ log_save (int babble, char *filename, in
 
   LogEnt *l;
 
-  for (l=first_logent; l; l=l->next)
+  for (l = first_logent; l; l = l->next)
     {
       if (babble || !(l->flags & LOG_BABBLE))
 	{
 	  fputs (l->msg, f);
-	  if (l->msg[strlen(l->msg)-1] != '\n')
+	  if (l->msg[strlen (l->msg) - 1] != '\n')
 	    fputc ('\n', f);
 	}
     }
Index: log.h
===================================================================
RCS file: /cvs/src/src/winsup/cinstall/log.h,v
retrieving revision 2.1
diff -u -p -r2.1 log.h
--- log.h	2000/08/25 01:32:08	2.1
+++ log.h	2001/11/11 06:54:57
@@ -20,13 +20,14 @@
 #define LOG_BABBLE	1
 #define LOG_TIMESTAMP	2
 
-void log (int flags, char *fmt, ...);
+void log (int flags, const char *fmt, ...)
+  __attribute__ ((format (printf, 2, 3)));
 
 /* Here, "babble" means to write out the babble also.  If "append" is
    nonzero, the log is appended to any existing file. */
 
-void log_save (int babble, char *filename, int append);
+void log_save (int babble, const char *filename, int append);
 
 /* This is the only legal way to exit.  It writes out all the logs and things */
 
-void exit_setup (int exit_code);
+void exit_setup (int exit_code) __attribute__ ((noreturn));
Index: main.cc
===================================================================
RCS file: /cvs/src/src/winsup/cinstall/main.cc,v
retrieving revision 2.8
diff -u -p -r2.8 main.cc
--- main.cc	2001/11/01 01:58:19	2.8
+++ main.cc	2001/11/11 06:54:57
@@ -23,7 +23,10 @@
    those don't count, although they could).  Replace the IDD_S_* with
    IDD_* if you create a real dialog for those steps. */
 
-static char *cvsid = "\n%%% $Id: main.cc,v 2.8 2001/11/01 01:58:19 rbcollins Exp $\n";
+#if 0
+static const char *cvsid =
+  "\n%%% $Id: main.cc,v 2.8 2001/11/01 01:58:19 rbcollins Exp $\n";
+#endif
 
 #include "win32.h"
 
@@ -62,10 +65,10 @@ void
 set_default_dacl ()
 {
   /* To assure that the created files have a useful ACL, the 
-  default DACL in the process token is set to full access to
-  everyone. This applies to files and subdirectories created
-  in directories which don't propagate permissions to child
-  objects. */
+     default DACL in the process token is set to full access to
+     everyone. This applies to files and subdirectories created
+     in directories which don't propagate permissions to child
+     objects. */
 
   /* Create a buffer which has enough room to contain the TOKEN_DEFAULT_DACL
      structure plus an ACL with one ACE. */
@@ -84,8 +87,8 @@ set_default_dacl ()
 
   /* Get the SID for "Everyone". */
   PSID sid;
-  SID_IDENTIFIER_AUTHORITY sid_auth = SECURITY_WORLD_SID_AUTHORITY;
-  if (!AllocateAndInitializeSid(&sid_auth, 1, 0, 0, 0, 0, 0, 0, 0, 0, &sid))
+  SID_IDENTIFIER_AUTHORITY sid_auth = { SECURITY_WORLD_SID_AUTHORITY };
+  if (!AllocateAndInitializeSid (&sid_auth, 1, 0, 0, 0, 0, 0, 0, 0, 0, &sid))
     {
       log (LOG_TIMESTAMP, "AllocateAndInitializeSid() failed: %lu",
 	   GetLastError ());
@@ -94,16 +97,18 @@ set_default_dacl ()
 
   /* Create the ACE which grants full access to "Everyone" and store it
      in dacl->DefaultDacl. */
-  if (!AddAccessAllowedAce (dacl->DefaultDacl, ACL_REVISION, GENERIC_ALL, sid))
+  if (!AddAccessAllowedAce
+      (dacl->DefaultDacl, ACL_REVISION, GENERIC_ALL, sid))
     {
-      log (LOG_TIMESTAMP, "AddAccessAllowedAce() failed: %lu", GetLastError ());
+      log (LOG_TIMESTAMP, "AddAccessAllowedAce() failed: %lu",
+	   GetLastError ());
       goto out;
     }
 
   /* Get the processes access token. */
   HANDLE token;
   if (!OpenProcessToken (GetCurrentProcess (),
-  			 TOKEN_READ | TOKEN_ADJUST_DEFAULT, &token))
+			 TOKEN_READ | TOKEN_ADJUST_DEFAULT, &token))
     {
       log (LOG_TIMESTAMP, "OpenProcessToken() failed: %lu", GetLastError ());
       goto out;
@@ -123,9 +128,7 @@ out:
 
 int WINAPI
 WinMain (HINSTANCE h,
-	 HINSTANCE hPrevInstance,
-	 LPSTR command_line,
-	 int cmd_show)
+	 HINSTANCE hPrevInstance, LPSTR command_line, int cmd_show)
 {
   hinstance = h;
 
@@ -144,7 +147,7 @@ WinMain (HINSTANCE h,
   for (argc = 0, argv = __argv; *argv; argv++)
     log (LOG_TIMESTAMP, "%d - '%s'\n", argc++, *argv);
   log (LOG_TIMESTAMP, "%d parameters passed\n", argc);
-  
+
   /* Set the default DACL only on NT/W2K. 9x/ME has no idea of access
      control lists and security at all. */
   if (iswinnt)
@@ -154,20 +157,48 @@ WinMain (HINSTANCE h,
     {
       switch (next_dialog)
 	{
-	case IDD_SPLASH:	do_splash (h);	break;
-	case IDD_SOURCE:	do_source (h);	break;
-	case IDD_LOCAL_DIR:	do_local_dir (h); break;
-	case IDD_ROOT:		do_root (h);	break;
-	case IDD_NET:		do_net (h);	break;
-	case IDD_SITE:		do_site (h);	break;
-	case IDD_OTHER_URL:	do_other (h);	break;
-	case IDD_S_LOAD_INI:	do_ini (h);	break;
-	case IDD_S_FROM_CWD:	do_fromcwd (h);	break;
-	case IDD_CHOOSE:	do_choose (h);	break;
-	case IDD_S_DOWNLOAD:	do_download (h); break;
-	case IDD_S_INSTALL:	do_install (h);	break;
-	case IDD_DESKTOP:	do_desktop (h); break;
-	case IDD_S_POSTINSTALL:	do_postinstall (h); break;
+	case IDD_SPLASH:
+	  do_splash (h);
+	  break;
+	case IDD_SOURCE:
+	  do_source (h);
+	  break;
+	case IDD_LOCAL_DIR:
+	  do_local_dir (h);
+	  break;
+	case IDD_ROOT:
+	  do_root (h);
+	  break;
+	case IDD_NET:
+	  do_net (h);
+	  break;
+	case IDD_SITE:
+	  do_site (h);
+	  break;
+	case IDD_OTHER_URL:
+	  do_other (h);
+	  break;
+	case IDD_S_LOAD_INI:
+	  do_ini (h);
+	  break;
+	case IDD_S_FROM_CWD:
+	  do_fromcwd (h);
+	  break;
+	case IDD_CHOOSE:
+	  do_choose (h);
+	  break;
+	case IDD_S_DOWNLOAD:
+	  do_download (h);
+	  break;
+	case IDD_S_INSTALL:
+	  do_install (h);
+	  break;
+	case IDD_DESKTOP:
+	  do_desktop (h);
+	  break;
+	case IDD_S_POSTINSTALL:
+	  do_postinstall (h);
+	  break;
 
 	default:
 	  next_dialog = 0;
@@ -176,4 +207,6 @@ WinMain (HINSTANCE h,
     }
 
   exit_setup (0);
+  /* Keep gcc happy :} */
+  return 0;
 }
Index: mkdir.cc
===================================================================
RCS file: /cvs/src/src/winsup/cinstall/mkdir.cc,v
retrieving revision 2.2
diff -u -p -r2.2 mkdir.cc
--- mkdir.cc	2001/05/27 07:05:09	2.2
+++ mkdir.cc	2001/11/11 06:54:57
@@ -15,7 +15,10 @@
 
 /* see mkdir.h */
 
-static char *cvsid = "\n%%% $Id: mkdir.cc,v 2.2 2001/05/27 07:05:09 cgf Exp $\n";
+#if 0
+static const char *cvsid =
+  "\n%%% $Id: mkdir.cc,v 2.2 2001/05/27 07:05:09 cgf Exp $\n";
+#endif
 
 #include "win32.h"
 
@@ -45,7 +48,8 @@ mkdir_p (int isadir, const char *in_path
 	{
 	  if (gse == ERROR_ALREADY_EXISTS)
 	    {
-	      fprintf (stderr, "warning: deleting \"%s\" so I can make a directory there\n",
+	      fprintf (stderr,
+		       "warning: deleting \"%s\" so I can make a directory there\n",
 		       path);
 	      if (DeleteFileA (path))
 		return mkdir_p (isadir, path);
Index: mklink2.c
===================================================================
RCS file: /cvs/src/src/winsup/cinstall/mklink2.c,v
retrieving revision 2.0
diff -u -p -r2.0 mklink2.c
--- mklink2.c	2000/08/08 00:27:54	2.0
+++ mklink2.c	2001/11/11 06:54:57
@@ -1,7 +1,12 @@
+#include <stdlib.h>
 #include "win32.h"
 #include "shlobj.h"
+#include "mklink2.h"
 
-static char *cvsid = "\n%%% $Id: mklink2.c,v 2.0 2000/08/08 00:27:54 dj Exp $\n";
+#if 0
+static const char *cvsid =
+  "\n%%% $Id: mklink2.c,v 2.0 2000/08/08 00:27:54 dj Exp $\n";
+#endif
 
 /* This part of the code must be in C because the C++ interface to COM
 doesn't work. */
@@ -11,7 +16,7 @@ make_link_2 (char *exepath, char *args, 
 {
   IShellLink *sl;
   IPersistFile *pf;
-  WCHAR widepath [_MAX_PATH];
+  WCHAR widepath[_MAX_PATH];
 
   CoCreateInstance (&CLSID_ShellLink, NULL,
 		    CLSCTX_INPROC_SERVER, &IID_IShellLink, (LPVOID *) & sl);
@@ -26,4 +31,31 @@ make_link_2 (char *exepath, char *args, 
 
   pf->lpVtbl->Release (pf);
   sl->lpVtbl->Release (sl);
+}
+
+#define SYMLINK_COOKIE "!<symlink>"
+
+/* Predicate: file is not currently in existence.
+ * A file race can occur otherwise.
+ */
+int
+mkcygsymlink (const char *from, const char *to)
+{
+  char buf[512];
+  unsigned long w;
+  HANDLE h = CreateFileA (from, GENERIC_WRITE, 0, 0, CREATE_NEW,
+		   FILE_ATTRIBUTE_NORMAL, 0);
+  if (h == INVALID_HANDLE_VALUE)
+    return 1;
+  strcpy (buf, SYMLINK_COOKIE);
+  strcat (buf, to);
+  if (WriteFile (h, buf, strlen (buf) + 1, &w, NULL))
+    {
+      CloseHandle (h);
+      SetFileAttributesA (from, FILE_ATTRIBUTE_SYSTEM);
+      return 0;
+    }
+  CloseHandle (h);
+  DeleteFileA (from);
+  return 1;
 }
Index: mount.cc
===================================================================
RCS file: /cvs/src/src/winsup/cinstall/mount.cc,v
retrieving revision 2.6
diff -u -p -r2.6 mount.cc
--- mount.cc	2001/10/31 13:15:05	2.6
+++ mount.cc	2001/11/11 06:54:57
@@ -17,7 +17,10 @@
    Cygwin's mount table.  If the format or location of the mount table
    changes, this is the file to change to match it. */
 
-static char *cvsid = "\n%%% $Id: mount.cc,v 2.6 2001/10/31 13:15:05 rbcollins Exp $\n";
+#if 0
+static const char *cvsid =
+  "\n%%% $Id: mount.cc,v 2.6 2001/10/31 13:15:05 rbcollins Exp $\n";
+#endif
 
 #include "win32.h"
 
@@ -34,18 +37,18 @@ static char *cvsid = "\n%%% $Id: mount.c
 #include "concat.h"
 
 static struct mnt
-  {
-    const char *native;
-    char *posix;
-    int istext;
-  } mount_table[255];
+{
+  const char *native;
+  char *posix;
+  int istext;
+}
+mount_table[255];
 
 struct mnt *root_here = NULL;
 
 static char *
 find2 (HKEY rkey, int *istext, char *what)
 {
-  char buf[1000];
   char *retval = 0;
   DWORD retvallen = 0;
   DWORD flags = 0;
@@ -59,8 +62,9 @@ find2 (HKEY rkey, int *istext, char *wha
       == ERROR_SUCCESS)
     {
       retval = (char *) malloc (MAX_PATH + 1);
-      if (RegQueryValueEx (key, "native", 0, &type, (BYTE *) retval, &retvallen)
-	  != ERROR_SUCCESS)
+      if (RegQueryValueEx
+	  (key, "native", 0, &type, (BYTE *) retval,
+	   &retvallen) != ERROR_SUCCESS)
 	{
 	  free (retval);
 	  retval = 0;
@@ -68,7 +72,7 @@ find2 (HKEY rkey, int *istext, char *wha
     }
 
   retvallen = sizeof (flags);
-  RegQueryValueEx (key, "flags", 0, &type, (BYTE *)&flags, &retvallen);
+  RegQueryValueEx (key, "flags", 0, &type, (BYTE *) & flags, &retvallen);
 
   RegCloseKey (key);
 
@@ -82,9 +86,8 @@ void
 create_mount (const char *posix, const char *win32, int istext, int issystem)
 {
   char buf[1000];
-  char *retval = 0;
   HKEY key;
-  DWORD retvallen = 0, disposition;
+  DWORD disposition;
   DWORD flags;
 
   remove_mount (posix);
@@ -92,23 +95,24 @@ create_mount (const char *posix, const c
   sprintf (buf, "Software\\%s\\%s\\%s\\%s",
 	   CYGWIN_INFO_CYGNUS_REGISTRY_NAME,
 	   CYGWIN_INFO_CYGWIN_REGISTRY_NAME,
-	   CYGWIN_INFO_CYGWIN_MOUNT_REGISTRY_NAME,
-	   posix);
+	   CYGWIN_INFO_CYGWIN_MOUNT_REGISTRY_NAME, posix);
 
   HKEY kr = issystem ? HKEY_LOCAL_MACHINE : HKEY_CURRENT_USER;
-  if (RegCreateKeyEx (kr, buf, 0, "Cygwin", 0, KEY_ALL_ACCESS,
+  if (RegCreateKeyEx (kr, buf, 0, (char *) "Cygwin", 0, KEY_ALL_ACCESS,
 		      0, &key, &disposition) != ERROR_SUCCESS)
     fatal ("mount");
 
-  RegSetValueEx (key, "native", 0, REG_SZ, (BYTE *) win32, strlen (win32) + 1);
+  RegSetValueEx (key, "native", 0, REG_SZ, (BYTE *) win32,
+		 strlen (win32) + 1);
   flags = 0;
   if (!istext)
     flags |= MOUNT_BINARY;
   if (issystem)
     flags |= MOUNT_SYSTEM;
-  RegSetValueEx (key, "flags", 0, REG_DWORD, (BYTE *)&flags, sizeof (flags));
-  
-  RegCloseKey(key);
+  RegSetValueEx (key, "flags", 0, REG_DWORD, (BYTE *) & flags,
+		 sizeof (flags));
+
+  RegCloseKey (key);
   read_mounts ();
 }
 
@@ -120,8 +124,7 @@ remove1 (HKEY rkey, const char *posix)
   sprintf (buf, "Software\\%s\\%s\\%s\\%s",
 	   CYGWIN_INFO_CYGNUS_REGISTRY_NAME,
 	   CYGWIN_INFO_CYGWIN_REGISTRY_NAME,
-	   CYGWIN_INFO_CYGWIN_MOUNT_REGISTRY_NAME,
-	   posix);
+	   CYGWIN_INFO_CYGWIN_MOUNT_REGISTRY_NAME, posix);
 
   RegDeleteKey (rkey, buf);
 }
@@ -144,28 +147,28 @@ set_cygdrive_flags (HKEY key, int istext
       else
 	cygdrive_flags &= ~MOUNT_BINARY;
       RegSetValueEx (key, CYGWIN_INFO_CYGDRIVE_FLAGS, 0, REG_DWORD,
-		     (BYTE *)&cygdrive_flags, sizeof (cygdrive_flags));
+		     (BYTE *) & cygdrive_flags, sizeof (cygdrive_flags));
     }
 }
 
 static LONG
-get_cygdrive_flags (HKEY key, DWORD *cygdrive_flags)
+get_cygdrive_flags (HKEY key, DWORD * cygdrive_flags)
 {
-  DWORD retvallen = sizeof(*cygdrive_flags);
+  DWORD retvallen = sizeof (*cygdrive_flags);
   LONG status = RegQueryValueEx (key, CYGWIN_INFO_CYGDRIVE_FLAGS, 0, 0,
-				 (BYTE *)cygdrive_flags, &retvallen);
+				 (BYTE *) cygdrive_flags, &retvallen);
   return status;
 }
 
 static DWORD
-default_cygdrive(HKEY key)
+default_cygdrive (HKEY key)
 {
   RegSetValueEx (key, CYGWIN_INFO_CYGDRIVE_PREFIX, 0, REG_SZ,
-		 (BYTE *)CYGWIN_INFO_CYGDRIVE_DEFAULT_PREFIX,
+		 (BYTE *) CYGWIN_INFO_CYGDRIVE_DEFAULT_PREFIX,
 		 strlen (CYGWIN_INFO_CYGDRIVE_DEFAULT_PREFIX) + 1);
   DWORD cygdrive_flags = MOUNT_AUTO;
   RegSetValueEx (key, CYGWIN_INFO_CYGDRIVE_FLAGS, 0, REG_DWORD,
-		 (BYTE *)&cygdrive_flags, sizeof (cygdrive_flags));
+		 (BYTE *) & cygdrive_flags, sizeof (cygdrive_flags));
   return cygdrive_flags;
 }
 
@@ -185,7 +188,7 @@ set_cygdrive_flags (int istext, int issy
       HKEY key;
       DWORD disposition;
       LONG status = RegCreateKeyEx (HKEY_LOCAL_MACHINE, buf, 0, 0, 0,
-      				    KEY_ALL_ACCESS, 0, &key, &disposition);
+				    KEY_ALL_ACCESS, 0, &key, &disposition);
       if (status == ERROR_SUCCESS)
 	{
 	  DWORD cygdrive_flags = 0;
@@ -195,14 +198,15 @@ set_cygdrive_flags (int istext, int issy
 	      set_cygdrive_flags (key, istext, cygdrive_flags);
 	      found_system = 1;
 	    }
-	  RegCloseKey(key);
+	  RegCloseKey (key);
 	}
     }
 
   HKEY key;
   DWORD disposition;
-  LONG status = RegCreateKeyEx (HKEY_CURRENT_USER, buf, 0, 0, 0, KEY_ALL_ACCESS,
-				0, &key, &disposition);
+  LONG status =
+    RegCreateKeyEx (HKEY_CURRENT_USER, buf, 0, 0, 0, KEY_ALL_ACCESS,
+		    0, &key, &disposition);
   if (status != ERROR_SUCCESS)
     fatal ("set_cygdrive_flags");
 
@@ -210,20 +214,20 @@ set_cygdrive_flags (int istext, int issy
   status = get_cygdrive_flags (key, &cygdrive_flags);
   if (status == ERROR_FILE_NOT_FOUND && !found_system)
     {
-      cygdrive_flags = default_cygdrive(key);
+      cygdrive_flags = default_cygdrive (key);
       status = ERROR_SUCCESS;
     }
 
   if (status == ERROR_SUCCESS)
     set_cygdrive_flags (key, istext, cygdrive_flags);
 
-  RegCloseKey(key);
+  RegCloseKey (key);
 }
 
 static int
 in_table (struct mnt *m)
 {
-  for (struct mnt *m1 = mount_table; m1 < m; m1++)
+  for (struct mnt * m1 = mount_table; m1 < m; m1++)
     if (strcasecmp (m1->posix, m->posix) == 0)
       return 1;
   return 0;
@@ -247,7 +251,7 @@ is_admin ()
 
   // Get the process token for the current process
   HANDLE token;
-  BOOL status = OpenProcessToken (GetCurrentProcess(), TOKEN_QUERY, &token);
+  BOOL status = OpenProcessToken (GetCurrentProcess (), TOKEN_QUERY, &token);
   if (!status)
     return 0;
 
@@ -255,26 +259,33 @@ is_admin ()
   UCHAR token_info[1024];
   PTOKEN_GROUPS groups = (PTOKEN_GROUPS) token_info;
   DWORD token_info_len = sizeof (token_info);
-  status = GetTokenInformation (token, TokenGroups, token_info, token_info_len, &token_info_len);
-  CloseHandle(token);
+  status =
+    GetTokenInformation (token, TokenGroups, token_info, token_info_len,
+			 &token_info_len);
+  CloseHandle (token);
   if (!status)
     return 0;
 
   // Create the Administrators group SID
   PSID admin_sid;
-  SID_IDENTIFIER_AUTHORITY authority = SECURITY_NT_AUTHORITY;
-  status = AllocateAndInitializeSid (&authority, 2, SECURITY_BUILTIN_DOMAIN_RID, DOMAIN_ALIAS_RID_ADMINS, 0, 0, 0, 0, 0, 0, &admin_sid);
+  SID_IDENTIFIER_AUTHORITY authority = { SECURITY_NT_AUTHORITY };
+  status =
+    AllocateAndInitializeSid (&authority, 2, SECURITY_BUILTIN_DOMAIN_RID,
+			      DOMAIN_ALIAS_RID_ADMINS, 0, 0, 0, 0, 0, 0,
+			      &admin_sid);
   if (!status)
     return 0;
 
   // Check to see if the user is a member of the Administrators group
   status = 0;
-  for (UINT i=0; i<groups->GroupCount; i++) {
-    if (EqualSid(groups->Groups[i].Sid, admin_sid)) {
-      status = 1;
-      break;
+  for (UINT i = 0; i < groups->GroupCount; i++)
+    {
+      if (EqualSid (groups->Groups[i].Sid, admin_sid))
+	{
+	  status = 1;
+	  break;
+	}
     }
-  }
 
   // Destroy the Administrators group SID
   FreeSid (admin_sid);
@@ -293,7 +304,7 @@ read_mounts ()
   char buf[10000];
 
   root_here = NULL;
-  for (mnt *m1 = mount_table; m1->posix; m1++)
+  for (mnt * m1 = mount_table; m1->posix; m1++)
     {
       free (m1->posix);
       if (m1->native)
@@ -313,10 +324,10 @@ read_mounts ()
 	       CYGWIN_INFO_CYGWIN_MOUNT_REGISTRY_NAME);
 
       HKEY key = issystem ? HKEY_LOCAL_MACHINE : HKEY_CURRENT_USER;
-      if (RegCreateKeyEx (key, buf, 0, "Cygwin", 0, KEY_ALL_ACCESS,
+      if (RegCreateKeyEx (key, buf, 0, (char *) "Cygwin", 0, KEY_ALL_ACCESS,
 			  0, &key, &disposition) != ERROR_SUCCESS)
 	break;
-      for (int i = 0; ;i++, m++)
+      for (int i = 0;; i++, m++)
 	{
 	  m->posix = (char *) malloc (MAX_PATH + 1);
 	  posix_path_size = MAX_PATH;
@@ -342,7 +353,7 @@ read_mounts ()
 	      m->native = find2 (key, &m->istext, m->posix);
 	      if (!m->native)
 		goto no_go;
-		  
+
 	      if (strcmp (m->posix, "/") == 0)
 		{
 		  root_here = m;
@@ -371,7 +382,7 @@ read_mounts ()
       m->posix = strdup ("/");
       char windir[_MAX_PATH];
       root_text = IDC_ROOT_BINARY;
-      root_scope = (is_admin()) ? IDC_ROOT_SYSTEM : IDC_ROOT_USER;
+      root_scope = (is_admin ())? IDC_ROOT_SYSTEM : IDC_ROOT_USER;
       GetWindowsDirectory (windir, sizeof (windir));
       windir[2] = 0;
       set_root_dir (concat (windir, "\\cygwin", 0));
@@ -425,8 +436,8 @@ char *
 cygpath (const char *s, ...)
 {
   va_list v;
-  int i, max_len = -1;
-  struct mnt *m, *match;
+  int max_len = -1;
+  struct mnt *m, *match = NULL;
 
   va_start (v, s);
   char *path = vconcat (s, v);
@@ -435,7 +446,7 @@ cygpath (const char *s, ...)
   if (strncmp (path, "/./", 3) == 0)
     memmove (path + 1, path + 3, strlen (path + 3) + 1);
 
-  for (m = mount_table; m->posix ; m++)
+  for (m = mount_table; m->posix; m++)
     {
       int n = strlen (m->posix);
       if (n < max_len || !path_prefix_p (m->posix, path, n))
@@ -444,8 +455,11 @@ cygpath (const char *s, ...)
       match = m;
     }
 
+  if (!match)
+    return NULL;
+
   char *native;
-  if (max_len == strlen (path))
+  if (max_len == (int) strlen (path))
     native = strdup (match->native);
   else
     native = concat (match->native, "/", path + max_len, NULL);
Index: mount.h
===================================================================
RCS file: /cvs/src/src/winsup/cinstall/mount.h,v
retrieving revision 2.3
diff -u -p -r2.3 mount.h
--- mount.h	2001/05/27 07:05:09	2.3
+++ mount.h	2001/11/11 06:54:57
@@ -17,13 +17,14 @@
    nonzero if the existing mount is a text mount, else zero for
    binary. */
 
-char *	find_mount (int *istext, int *issystem, char *path);
+char *find_mount (int *istext, int *issystem, char *path);
 
 /* Similar to the mount and umount functions, but simplified */
 
-void	create_mount (const char *posix, const char *win32, int istext, int issystem);
-void	remove_mount (const char *posix);
-void	read_mounts ();
+void create_mount (const char *posix, const char *win32, int istext,
+		   int issystem);
+void remove_mount (const char *posix);
+void read_mounts ();
 
 /* Sets the cygdrive flags.  Used to make the automounted drives' binary/text
 mode consistent with the standard Cygwin mounts. */
Index: msg.cc
===================================================================
RCS file: /cvs/src/src/winsup/cinstall/msg.cc,v
retrieving revision 2.1
diff -u -p -r2.1 msg.cc
--- msg.cc	2000/08/25 01:32:08	2.1
+++ msg.cc	2001/11/11 06:54:57
@@ -16,7 +16,10 @@
 /* The purpose of this file is to centralize all the message
    functions. */
 
-static char *cvsid = "\n%%% $Id: msg.cc,v 2.1 2000/08/25 01:32:08 dj Exp $\n";
+#if 0
+static const char *cvsid =
+  "\n%%% $Id: msg.cc,v 2.1 2000/08/25 01:32:08 dj Exp $\n";
+#endif
 
 #include "win32.h"
 #include <stdio.h>
@@ -25,7 +28,7 @@ static char *cvsid = "\n%%% $Id: msg.cc,
 #include "log.h"
 
 void
-msg (char *fmt, ...)
+msg (const char *fmt, ...)
 {
   char buf[1000];
   va_list args;
@@ -35,7 +38,7 @@ msg (char *fmt, ...)
 }
 
 static int
-mbox (char *name, int type, int id, va_list args)
+mbox (const char *name, int type, int id, va_list args)
 {
   char buf[1000], fmt[1000];
 
Index: msg.h
===================================================================
RCS file: /cvs/src/src/winsup/cinstall/msg.h,v
retrieving revision 2.0
diff -u -p -r2.0 msg.h
--- msg.h	2000/08/08 00:27:54	2.0
+++ msg.h	2001/11/11 06:54:57
@@ -17,7 +17,7 @@
    OutputDebugString, which can be seen while debugging under GDB or
    via a debug message monitor. */
 
-void msg(char *fmt, ...);
+void msg (const char *fmt, ...);
 
 /* This pops up a dialog with text from the string table ("id"), which
    is interpreted like printf.  The program exits when the user
Index: net.cc
===================================================================
RCS file: /cvs/src/src/winsup/cinstall/net.cc,v
retrieving revision 2.6
diff -u -p -r2.6 net.cc
--- net.cc	2001/11/01 13:22:46	2.6
+++ net.cc	2001/11/11 06:54:57
@@ -16,7 +16,10 @@
 /* The purpose of this file is to get the network configuration
    information from the user. */
 
-static char *cvsid = "\n%%% $Id: net.cc,v 2.6 2001/11/01 13:22:46 rbcollins Exp $\n";
+#if 0
+static const char *cvsid =
+  "\n%%% $Id: net.cc,v 2.6 2001/11/01 13:22:46 rbcollins Exp $\n";
+#endif
 
 #include "win32.h"
 #include <stdio.h>
@@ -108,6 +111,7 @@ dialog_cmd (HWND h, int id, HWND hwndctl
       NEXT (0);
       break;
     }
+  return 0;
 }
 
 static BOOL CALLBACK
@@ -119,11 +123,14 @@ dialog_proc (HWND h, UINT message, WPARA
       load_dialog (h);
 
       // Check to see if any radio buttons are selected. If not, select a default.
-      if ((!SendMessage(GetDlgItem (h, IDC_NET_IE5), BM_GETCHECK, 0, 0) == BST_CHECKED)
-        && (!SendMessage(GetDlgItem (h, IDC_NET_PROXY), BM_GETCHECK, 0, 0) == BST_CHECKED))
-        {
-          SendMessage(GetDlgItem (h, IDC_NET_DIRECT), BM_CLICK, 0, 0);
-        }
+      if (
+	  (!SendMessage (GetDlgItem (h, IDC_NET_IE5), BM_GETCHECK, 0, 0) ==
+	   BST_CHECKED)
+	  && (!SendMessage (GetDlgItem (h, IDC_NET_PROXY), BM_GETCHECK, 0, 0)
+	      == BST_CHECKED))
+	{
+	  SendMessage (GetDlgItem (h, IDC_NET_DIRECT), BM_CLICK, 0, 0);
+	}
       return FALSE;
     case WM_COMMAND:
       return HANDLE_WM_COMMAND (h, wParam, lParam, dialog_cmd);
@@ -145,4 +152,3 @@ do_net (HINSTANCE h)
        (net_method == IDC_NET_IE5) ? "IE5" :
        (net_method == IDC_NET_DIRECT) ? "Direct" : "Proxy");
 }
-
Index: netio.cc
===================================================================
RCS file: /cvs/src/src/winsup/cinstall/netio.cc,v
retrieving revision 2.3
diff -u -p -r2.3 netio.cc
--- netio.cc	2001/05/28 08:31:02	2.3
+++ netio.cc	2001/11/11 06:54:57
@@ -17,7 +17,10 @@
    methods known to setup.  To add a new method, create a pair of
    nio-*.[ch] files and add the logic to NetIO::open here */
 
-static char *cvsid = "\n%%% $Id: netio.cc,v 2.3 2001/05/28 08:31:02 corinna Exp $\n";
+#if 0
+static const char *cvsid =
+  "\n%%% $Id: netio.cc,v 2.3 2001/05/28 08:31:02 corinna Exp $\n";
+#endif
 
 #include "win32.h"
 #include <stdio.h>
@@ -78,7 +81,7 @@ NetIO::set_url (char *Purl)
   *ep = 0;
   proto = _strdup (bp);
   *ep = ':';
-  bp = ep+3;
+  bp = ep + 3;
 
   ep = bp + strcspn (bp, ":/");
   c = *ep;
@@ -88,7 +91,7 @@ NetIO::set_url (char *Purl)
 
   if (*ep == ':')
     {
-      port = atoi (ep+1);
+      port = atoi (ep + 1);
       ep = strchr (ep, '/');
     }
 
@@ -112,7 +115,9 @@ NetIO *
 NetIO::open (char *url, BOOL allow_ftp_auth)
 {
   NetIO *rv = 0;
-  enum {http, ftp, file} proto;
+  enum
+  { http, ftp, file }
+  proto;
   if (strncmp (url, "http://", 7) == 0)
     proto = http;
   else if (strncmp (url, "ftp://", 6) == 0)
@@ -136,6 +141,9 @@ NetIO::open (char *url, BOOL allow_ftp_a
 	case ftp:
 	  rv = new NetIO_FTP (url, allow_ftp_auth);
 	  break;
+	case file:
+	  rv = new NetIO_File (url);
+	  break;
 	}
     }
 
@@ -203,6 +211,7 @@ auth_cmd (HWND h, int id, HWND hwndctl, 
       exit_setup (1);
       break;
     }
+  return 0;
 }
 
 static BOOL CALLBACK
Index: netio.h
===================================================================
RCS file: /cvs/src/src/winsup/cinstall/netio.h,v
retrieving revision 2.2
diff -u -p -r2.2 netio.h
--- netio.h	2001/05/28 08:31:02	2.2
+++ netio.h	2001/11/11 06:54:57
@@ -16,7 +16,8 @@
 /* This is the parent class for all the access methods known to setup
    (i.e. ways to download files from the internet or other sources */
 
-class NetIO {
+class NetIO
+{
 protected:
   NetIO (char *url, BOOL allow_ftp_auth = FALSE);
   void set_url (char *url);
@@ -31,13 +32,13 @@ public:
   char *host;
   int port;
   char *path;
-  virtual ~NetIO ();
+    virtual ~ NetIO ();
 
   /* The user calls this function to create a suitable accessor for
      the given URL.  It uses the network setup state in state.h.  If
      anything fails, either the return values is NULL or the returned
      object is !ok() */
-  static NetIO * open (char *url, BOOL allow_ftp_auth = FALSE);
+  static NetIO *open (char *url, BOOL allow_ftp_auth = FALSE);
 
   /* If !ok() that means the transfer isn't happening. */
   virtual int ok ();
Index: nio-file.cc
===================================================================
RCS file: /cvs/src/src/winsup/cinstall/nio-file.cc,v
retrieving revision 2.2
diff -u -p -r2.2 nio-file.cc
--- nio-file.cc	2001/06/13 16:11:01	2.2
+++ nio-file.cc	2001/11/11 06:54:57
@@ -16,7 +16,10 @@
 /* The purpose of this file is to manage access to files stored on the
    local disk (i.e. "downloading" setup.ini).  Called from netio.cc */
 
-static char *cvsid = "\n%%% $Id: nio-file.cc,v 2.2 2001/06/13 16:11:01 cgf Exp $\n";
+#if 0
+static const char *cvsid =
+  "\n%%% $Id: nio-file.cc,v 2.2 2001/06/13 16:11:01 cgf Exp $\n";
+#endif
 
 #include "win32.h"
 #include <stdio.h>
@@ -29,18 +32,17 @@ static char *cvsid = "\n%%% $Id: nio-fil
 #include "msg.h"
 #include "filemanip.h"
 
-NetIO_File::NetIO_File (char *Purl)
-  : NetIO (Purl)
+NetIO_File::NetIO_File (char *Purl):
+NetIO (Purl)
 {
-  struct stat s;
   fd = fopen (path, "rb");
   if (fd)
     {
-      file_size = get_file_size(path);
+      file_size = get_file_size (path);
     }
   else
     {
-      char *err = strerror (errno);
+      const char *err = strerror (errno);
       if (!err)
 	err = "(unknown error)";
       note (IDS_ERR_OPEN_READ, path, err);
@@ -50,7 +52,7 @@ NetIO_File::NetIO_File (char *Purl)
 NetIO_File::~NetIO_File ()
 {
   if (fd)
-    fclose ((FILE *)fd);
+    fclose ((FILE *) fd);
 }
 
 int
@@ -62,5 +64,5 @@ NetIO_File::ok ()
 int
 NetIO_File::read (char *buf, int nbytes)
 {
-  return fread (buf, 1, nbytes, (FILE *)fd);
+  return fread (buf, 1, nbytes, (FILE *) fd);
 }
Index: nio-file.h
===================================================================
RCS file: /cvs/src/src/winsup/cinstall/nio-file.h,v
retrieving revision 2.0
diff -u -p -r2.0 nio-file.h
--- nio-file.h	2000/08/08 00:27:54	2.0
+++ nio-file.h	2001/11/11 06:54:57
@@ -15,11 +15,12 @@
 
 /* see nio-file.cc */
 
-class NetIO_File : public NetIO {
+class NetIO_File:public NetIO
+{
 public:
   NetIO_File (char *url);
   void *fd;
-  ~NetIO_File ();
+   ~NetIO_File ();
   virtual int ok ();
   virtual int read (char *buf, int nbytes);
 };
